<?php
/**
 * <pre>
 * Invision Power Services
 * IP.Nexus ACP Skin - Support Staff Audit
 * Last Updated: $Date: 2011-05-25 10:30:28 -0400 (Wed, 25 May 2011) $
 * </pre>
 *
 * @author 		$Author: ips_terabyte $ (Orginal: Mark)
 * @copyright	(c) 2010 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/company/standards.php#license
 * @package		IP.Nexus
 * @link		http://www.invisionpower.com
 * @since		11th April 2010
 * @version		$Revision: 8887 $
 */
 
class cp_skin_reports_supportaudit
{

	/**
	 * Constructor
	 *
	 * @param	object		$registry		Registry object
	 * @return	@e void
	 */
	public function __construct( ipsRegistry $registry )
	{
		$this->registry 	= $registry;
		$this->DB	    	= $this->registry->DB();
		$this->settings		=& $this->registry->fetchSettings();
		$this->request		=& $this->registry->fetchRequest();
		$this->member   	= $this->registry->member();
		$this->memberData	=& $this->registry->member()->fetchMemberData();
		$this->cache		= $this->registry->cache();
		$this->caches		=& $this->registry->cache()->fetchCaches();
		$this->lang 		= $this->registry->class_localization;
	}

//===========================================================================
// Splash
//===========================================================================
function splash() {

$form['staff'] = ipsRegistry::getClass('output')->formDropDown( 'staff', supportRequest::getStaffList(), '' );
$form['days'] = ipsRegistry::getClass('output')->formSimpleInput( 'days', '5' );

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<HTML

<div class='section_title'>
	<h2>{$this->registry->getClass('class_localization')->words['supportaudit_title']}</h2>
</div>

<div class='acp-box'>
	<h3>{$this->registry->getClass('class_localization')->words['supportaudit_title']}</h3>
	<form action='{$this->settings['base_url']}&amp;module=reports&amp;section=supportaudit&amp;do=report' method='post'>
	<table class='ipsTable double_pad'>
		<tr>
			<td class='field_title'><strong class='title'>{$this->registry->getClass('class_localization')->words['supportaudit_staff']}</strong></td>
			<td class='field_field'>
				{$form['staff']}
			</td>
		</tr>
		<tr>
			<td class='field_title'><strong class='title'>{$this->registry->getClass('class_localization')->words['supportaudit_days']}</strong></td>
			<td class='field_field'>
				{$form['days']}
			</td>
		</tr>
	</table>
	<div class="acp-actionbar">
		<input type='submit' value='{$this->registry->getClass('class_localization')->words['supportaudit_go']}' class='realbutton'>
	</div>
	</form>
</div>
HTML;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// Report
//===========================================================================
function report( $staff, $rows, $columns, $results ) {

$title = sprintf( $this->registry->getClass('class_localization')->words['supportaudit_title_staff'], $staff['members_display_name'] );

$totals = array();

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<HTML

<div class='section_title'>
	<h2>{$title}</h2>
</div>

<div class='acp-box'>
 	<h3>{$title}</h3>
	<table class='ipsTable'>
		<tr>
			<th width='20%'>&nbsp;</th>
HTML;
foreach ( $columns as $k => $v )
{
	$IPBHTML .= <<<HTML
			<th>{$v}</th>
HTML;
}

$IPBHTML .= <<<HTML
			<th>{$this->registry->getClass('class_localization')->words['supportaudit_total']}</th>
HTML;
		if ( $this->registry->getClass('class_permissions')->checkPermission( 'sr_ratings', 'nexus', 'tickets' ) )
		{
			$IPBHTML .= <<<HTML
			<th>{$this->registry->getClass('class_localization')->words['supportaudit_rating']}</th>
HTML;
		}
		$IPBHTML .= <<<HTML
		</tr>
HTML;

foreach ( $rows as $dateSystem => $dateHuman )
{
	$totals[ $dateSystem ] = 0;
	$ratings[ $dateSystem ] = array();

	$IPBHTML .= <<<HTML
		<tr>
			<td>{$dateHuman}</td>
HTML;

foreach ( $columns as $hourSystem => $hourHuman )
{
	if ( isset( $results[ $dateSystem ][ $hourSystem ] ) )
	{
		$totals[ $dateSystem ] += $results[ $dateSystem ][ $hourSystem ]['count'];
		
		if ( $results[ $dateSystem ][ $hourSystem ]['rating'] )
		{
			$ratings[ $dateSystem ][] = $results[ $dateSystem ][ $hourSystem ]['rating'];
		}
		
		$IPBHTML .= <<<HTML
			<td><a href='{$this->settings['base_url']}&amp;module=reports&amp;section=supportaudit&amp;do=locate&amp;staff={$staff['member_id']}&amp;date={$dateSystem}&amp;time={$hourSystem}'>{$results[ $dateSystem ][ $hourSystem ]['count']}</a></td>
HTML;
	}
	else
	{
		$IPBHTML .= <<<HTML
			<td>&nbsp;</td>
HTML;
	}
}

	if ( $totals[ $dateSystem ] > 0 )
	{
		$IPBHTML .= <<<HTML
			<td><span class='larger_text'><a href='{$this->settings['base_url']}&amp;module=reports&amp;section=supportaudit&amp;do=locate&amp;staff={$staff['member_id']}&amp;date={$dateSystem}'>{$totals[ $dateSystem ]}</a></span></td>
HTML;
	}
	else
	{
		$IPBHTML .= <<<HTML
			<td><span class='larger_text'>0</span></td>
HTML;
	}
	
	if ( $this->registry->getClass('class_permissions')->checkPermission( 'sr_ratings', 'nexus', 'tickets' ) )
	{
		$avgRating = empty( $ratings[ $dateSystem ] ) ? 0 : ( array_sum( $ratings[ $dateSystem ] ) / count( $ratings[ $dateSystem ] ) );
		$IPBHTML .= <<<HTML
			<td>{$avgRating}</td>
HTML;
	}
	
	$IPBHTML .= <<<HTML
		</tr>
HTML;


}

$IPBHTML .= <<<HTML
	</table>
</div>

HTML;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// View Replies
//===========================================================================
function view( $staff, $replies ) {

$title = sprintf( $this->registry->getClass('class_localization')->words['supportaudit_title_staff'], $staff['members_display_name'] );

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<HTML

<div class='section_title'>
	<h2>{$title}</h2>
</div>

<div class='acp-box'>
	<h3>{$title}</h3>
	<div id='ticket_replies'>
	
HTML;

	foreach ( $replies as $message )
	{
		$request = sprintf( $this->registry->getClass('class_localization')->words['supportaudit_from'], "<a href='{$this->settings['base_url']}&amp;module=tickets&amp;section=view&amp;id={$message['reply_request']}'>{$message['r_title']}</a>" );
	
		$IPBHTML .= <<<HTML
		
		<div id='reply_{$message['reply_id']}' class='post_block clear type_{$message['reply_type']}'>
		<div class='post_wrap'>
			<label for='act_{$message['reply_id']}'>
				<div class='bar'>
					<span style='font-weight:bold'>{$request}</span></span>
				</div>
			</label>
			<div class='author_info'>
				<img src='{$staff['pp_small_photo']}' width="{$staff['pp_smallb_width']}" height="{$staff['pp_small_height']}" class='photo' />
			</div>
			<div class='post_body clearfix'>
				<p class='posted_info desctext'>{$message['reply_date']}</p>
				<div class='post'>
					{$message['reply_post']}
				</div>
HTML;
				if ( $this->settings['nexus_support_satisfaction'] and $message['reply_type'] == 's' and $this->registry->getClass('class_permissions')->checkPermission( 'sr_ratings', 'nexus', 'tickets' ) )
				{	
					$IPBHTML .= <<<EOF
						<div class='post desctext right'>
EOF;
					if ( $message['rating_rating'] )
					{
						if ( $message['rating_note'] and $this->registry->getClass('class_permissions')->checkPermission( 'sr_ratings_feedback', 'nexus', 'tickets' ) )
						{
						$IPBHTML .= <<<EOF
							<div id='rating_feedback_{$message['reply_id']}' class='popupWrapper' style='display:none'>
								<div class='popupInner'>
									{$message['rating_note']}
								</div>
							</div>
							<a class='clickable' onclick="new ipb.Popup('feedback_box_{$message['replyid']}', { type: 'balloon', stem: true, attach: { target: this, position: 'auto' }, hideAtStart: false, w: '650px', initial: $('rating_feedback_{$message['reply_id']}').innerHTML } );">{$this->lang->words['support_rating']}</a>
EOF;
						}
						else
						{
							$IPBHTML .= $this->lang->words['support_rating'];
						}
					
						for ( $i=1; $i < 6; $i++ )
						{
							if ( $message['rating_rating'] >= $i )
							{
								$IPBHTML .= <<<EOF
									<img src='{$this->settings['skin_app_url']}/images/support/star.png' alt='' />
EOF;
							}
							else
							{
								$IPBHTML .= <<<EOF
									<img src='{$this->settings['skin_app_url']}/images/support/star-empty.png' alt='' />
EOF;
							}
						}
					}
					else
					{
						$IPBHTML .= $this->lang->words['support_rating_none'];
					}
					
						$IPBHTML .= <<<EOF
						</div>
EOF;
				}
				$IPBHTML .= <<<HTML
			</div>
		</div>
	</div>
HTML;

	}
	
	$IPBHTML .= <<<HTML
	</div>
</div>


HTML;

//--endhtml--//
return $IPBHTML;
}

}